
#define XtNgeoTattler "geoTattler"
#define XtCGeoTattler "GeoTattler"

/* not found anywhere in Xt, so define this one */
#define XtClassName(w) XtClass(w)->core_class.class_name



#if NeedFunctionPrototypes
extern Boolean _GeoIsTattled (Widget widget);
extern Boolean _GeoIsCached (Widget widget, Boolean* is_geotattled);
extern void _GeoChangeCache (Widget widget, Boolean geo_tat);
extern void _GeoCache (Widget widget, Boolean geo_tat);
extern void _GeoTabTrace (void);
extern void _GeoUnTabTrace (void);
extern void _GeoPrintTab (void);
#else
extern Boolean _GeoIsTattled ();
extern Boolean _GeoIsCached ();
extern void _GeoChangeCache ();
extern void _GeoCache ();
extern void _GeoTabTrace ();
extern void _GeoUnTabTrace ();
extern void _GeoPrintTab ();
#endif

#if NeedVarargsPrototypes
extern void _GeoPrintTrace (Widget widget, ...);
#else
extern void _GeoPrintTrace ();
#endif



/* some useful macros */

#define GMode(g)	    ((g)->request_mode)
#define IsX(g)		    (GMode (g) & CWX)
#define IsY(g)		    (GMode (g) & CWY)
#define IsWidth(g)	    (GMode (g) & CWWidth)
#define IsHeight(g)	    (GMode (g) & CWHeight)
#define IsBorder(g)	    (GMode (g) & CWBorderWidth)
#define IsWidthHeight(g)    ((GMode (g) & CWWidth) || (GMode (g) & CWHeight))
#define IsQueryOnly(g)      (GMode (g) & XtCWQueryOnly)
